from apiclient.discovery import build

import urllib
import urllib2
import simplejson as json

import zbrowse as webbrowser
import BaseHTTPServer
import logging
import socket
import sys
import zurl

import httplib2
import pickle
import sys
import time

from apiclient.discovery import build
from apiclient.oauth import FlowThreeLegged

# Uncomment to get detailed logging
# httplib2.debuglevel = 4

# Simple pickle-storage module by Zap.... can it be simpler? ;)
class Storage:
    def __init__(self, filename):
        self.filename = filename
    def put(self, data):
        f = open(self.filename, "w")
        pickle.dump(data, f)
        f.close()
    def get(self):
        try:
            f = open(self.filename)
            result = pickle.load(f)
            f.close()
            return result
        except:
            return None


class Service():

    #client OAuth keys
    key    = '989316022849.apps.googleusercontent.com'
    secret = 'Wlc_ppFDjGYpgsxAetT6lAWA'
    
    # Latitude URIs and callbacks
    callback_url           = "http://localhost:8080"
    authorization_endpoint = "https://accounts.google.com/o/oauth2/auth"
    access_token_endpoint  = "https://accounts.google.com/o/oauth2/token"

    def refresh_auth(self):
        #construct POST object for access token fetch request
        print "Refreshing Latitude auth token...."
        postvals = {'grant_type': 'refresh_token', 'client_id': self.key, 'client_secret': self.secret, 'refresh_token': self.token["refresh_token"]}
        
        #make request to capture access token
        params = urllib.urlencode(postvals)
        f = urllib.urlopen(self.access_token_endpoint, params)

        # Seems I need to remember the refresh token(!?)
        rtok = self.token["refresh_token"]        
        self.token = json.load(f)
        self.token["refresh_token"] = rtok

        # print self.token
        
        # Compute actual expiration time
        self.token["expiration_time"] = self.token["expires_in"] + time.time() # - (24*60*60)
        
        # print self.token
        
        f = open("/home/user/.zaploc/latitude.dat", "w")
        pickle.dump(self.token, f)
        f.close()
        
        print "Completed token refresh!"
    
    
    def is_authorized(self):    
        #get query string parameters
        # params = cgi.FieldStorage()
           
        try:
            f = open("/home/user/.zaploc/latitude.dat")
            if f:
                self.token = pickle.load(f)
            f.close();

            # print self.token

            expired = False
            
            try:
                expiry_time = self.token["expiration_time"]
                if time.time() > expiry_time:
                    expired = True
            except:
                expired = True
            
            if expired:
                self.refresh_auth()
            
            return True
        except:            
            return False
        
 
    def authorize(self):                                       
        host_name = 'localhost'
        port_numbers = [8080, 8090]
        if True:
          server_class = BaseHTTPServer.HTTPServer
          zurl.RedirectHandler.service = "Latitude"
          zurl.RedirectHandler.token   = "code"
          try:
            port_number = port_numbers[0]
            httpd = server_class((host_name, port_number), zurl.RedirectHandler)
          except socket.error:
            port_number = port_numbers[1]
            try:
              httpd = server_class((host_name, port_number), zurl.RedirectHandler)
            except socket.error:
              options.localhost = False
    
        #construct Latitude authorization URI
        auth_url = self.authorization_endpoint + "?redirect_uri=" + self.callback_url + "&client_id=" + self.key + "&response_type=code&scope=https://www.googleapis.com/auth/latitude.current.best https://www.googleapis.com/auth/userinfo.profile"        
        #redirect the user to the Latitude authorization URI
        webbrowser.open(auth_url)
              
        if True:
          httpd.handle_request()

          if 'error' in httpd.query_params:
            sys.exit('Authentication request was rejected.')
          if 'code' in httpd.query_params:
            code = httpd.query_params['code']

            #construct POST object for access token fetch request
            postvals = {'grant_type': 'authorization_code', 'client_id': self.key, 'client_secret': self.secret, 'code': code, 'redirect_uri': self.callback_url}
            
            #make request to capture access token
            params = urllib.urlencode(postvals)
            f = urllib.urlopen(self.access_token_endpoint, params)

            self.token = json.load(f)

            # print self.token
            
            if "error" in self.token:
                return False

            # Compute actual expiration time
            self.token["expiration_time"] = self.token["expires_in"] + time.time() # - (24*60*60)
        
            f = open("/home/user/.zaploc/latitude.dat", "w")
            pickle.dump(self.token, f)
            f.close()

            return True
            
    def get_icon(self):
        headers = { 'Accept': 'application/json' }

        if True: # try:
            list_url = "https://www.googleapis.com/oauth2/v1/userinfo?access_token="
            list_url += self.token['access_token']

            request  = urllib2.Request(list_url, None, headers)
            response = urllib2.urlopen(request)
            
            data = json.load(response)       

            # print data
            
            pic = zurl.load_url_image(data["picture"], 1.0, "fsicon")[0]
            
            return pic
        else: # except:
            return None
                
    def list_spots(self, my_pos, radius):
        return []

    def list_friends(self, my_pos):
        return []

    def get_description(self, spot):
        return ( "Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry's standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged.", None )
      
    def check_in(self, my_pos, text, twitter = False, facebook = False, photo = None):
        self.is_authorized()

        #build headers for protected data request
        headers = { 'Content-Type': 'application/json',
	            'Authorization': 'Bearer ' + self.token["access_token"]}

        # Make URL-safe
        checkin_url = 'https://www.googleapis.com/latitude/v1/currentLocation'
	
        postvals = { 
	    "data": { 
	        "kind":        "latitude#location",
	        "latitude":    my_pos[0], 
	        "longitude":   my_pos[1],
	        # "altitude":  my_pos[2],
	        "accuracy":    my_pos[3]
	    }
	}

	
        try:
	    params = json.dumps(postvals)
	    
            request  = urllib2.Request(checkin_url, params, headers)

            f = urllib2.urlopen(request)
                            
            result = json.load(f)

	    return ["Checked you in at %g, %g on Latitude" % (my_pos[0], my_pos[1])]
	
	except:
	    return None
    
    def can_post_photo(self):
        return False
    
    def name(self):
        return "Google Latitude"
    
    def cfgname(self):
        return "latitude"
    
    def onimg(self):
        return "gfx/lton.png"
    
    def offimg(self):
        return "gfx/ltoff.png"    

    def tweetable(self):
        return False
        
    def facebookable(self):
        return False

    def poscheckin(self):
        return True

# Unit test    
if __name__ == '__main__': 
    boo = Service()
    if boo.is_authorized() == False:
        boo.authorize()    
    
    boo.get_icon()
    pos = (59.37096, 16.51406, 35, 50)

    boo.check_in(pos, "Hello!")
